/*
Stallation version 0.7  (2000-06-28)

Written by Peter Folk <pfolk@uni.uiuc.edu>

The contents of this file are in the public domain, but
the author would appreciate it if any useful changes or
corrections were communicated back to him, for inclusion
in a future version.
*/
#ifndef GARGOYLE_STALLAPP_H
#define GARGOYLE_STALLAPP_H
#include "Stallation.h"
#include <be/app/Application.h>
#include <be/app/Roster.h>
#include <be/interface/Alert.h>

typedef status_t (*expander)(cc*,cc*);

class InstallationManager;
class StallApp: public BApplication
{
	bool gotRefs;
	
	InstallationManager *win;
	
	struct Expansion
	{
		cc* ext;
		status_t (*expand)(const entry_ref&, entry_ref*);
	};
	vector<expander> expanders;
	
	status_t Expand(cc* path, cc* dest);
	void StripZip(BString*); 
	status_t LoadExpanders();
	void INSTALL(const entry_ref& ref, bool interact);
  public:
	StallApp();
	virtual ~StallApp();
	
	virtual void RefsReceived(BMessage *);
	virtual void ReadyToRun();
};
#endif
